library ieee;
use ieee.std_logic_1164.all;

entity multiplex is
end multiplex;

architecture behave of multiplex is
signal input: std_logic_vector(3 downto 0);
signal sel: std_logic_vector(1 downto 0);
signal q: std_logic;
signal clk: bit := '1';
begin
--  clk <= not clk after 20 ns;

  with sel select
    q <= input(0) after 20 ns when "00",
         input(1) after 20 ns when "01",
         input(2) after 20 ns when "10",
         input(3) after 20 ns when "11",
         'X' after 20 ns when others;


  input <= "1011" after 10 ns, "0100" after 30 ns,
           "1001" after 50 ns, "0010" after 70 ns;
  sel <= "00" after 10 ns, "01" after 30 ns, "10" after 50 ns,
         "11" after 70 ns;
end behave;

configuration mux_config of multiplex is
for behave end for;
end mux_config;

